% Constraint function for ( AA + diag( xx ) ) >= 0 constraint
%
% AA is the matrix
% xx is the current iterate
%
% value is the constraint value at xx
% gradient( ii, :, : ) is the matrix derivative of the constraint with respect
%     to xx_ii evaluated at xx
% hessian( ii, jj, :, : ) is the matrix second derivative of the constraint
%     with respect to xx_ii*xx_jj evaluated at xx
%
function [ value, gradient, hessian ] = constraint_sdp( AA, xx )

	value = AA + diag( xx );

	if ( nargout > 1 )

		%gradient = ( TODO: gradient );
		%    NOTE: gradient should be a THREE dimensional matrix, with
		%    gradient( ii, jj, kk ) being the partial derivative of
		%    AA( jj, kk ) with respect to xx( ii ), evaluated at xx

		if ( nargout > 2 )
			%hessian = ( TODO: hessian );
			%    NOTE: hessian should be a FOUR dimensional matrix, with
			%    hessian( ii, jj, kk, ll ) being the partial derivative of
			%    AA( kk, ll ) with respect to xx( ii ) * xx( jj ), evaluated
			%    at xx
		end
	end

end
