QQ = [ 5, 2; 2, 2 ];
vv = [ 21; 13 ];
AA = [ 2, 1 ; 2, -5 ; -1, 1 ];
bb = [ 8; 10; 3 ];
mm = 2 + length( bb );

initial_xx = [ 0; 0 ];
epsilon = 1e-8;

tt = mm;

ff = @( xx ) objective_quadratic_log_barrier( QQ, vv, AA, bb, xx, tt );
line_search = @( ff, xx, direction ) line_search_backtracking( ff, xx, direction, 0.4, 0.9 );


[ XX, YY ] = meshgrid( -4:0.1:2, -4:0.1:2 );
ZZ = 0.5 * ( QQ( 1, 1 ) * ( XX .* XX ) + ( QQ( 1, 2 ) + QQ( 2, 1 ) ) * ( XX .* YY ) + QQ( 2, 2 ) * ( YY .* YY ) ) + vv( 1 ) * XX + vv( 2 ) * YY;
lower = sqrt( min( min( ZZ ) ) );
upper = sqrt( max( max( ZZ ) ) );

[ xx, values, runtimes, gd_xxs ] = algorithm_gd( ff, initial_xx, line_search, epsilon );
gd_iterations = length( values ) - 1;
[ xx, values, runtimes, newton_xxs ] = algorithm_newton( ff, initial_xx, line_search, epsilon );
newton_iterations = length( values ) - 1;

contour( XX, YY, ZZ, ( ( 0.05:0.1:0.95 ) * ( upper - lower ) + lower ) .^ 2 );
colormap( gray );
hold on;
for ii = 1:length( bb )
	aaii = AA( ii, : )' / norm( AA( ii, : ) );
	bbii = bb( ii ) / norm( AA( ii, : ) );
	center = -aaii * bbii;
	aaii_perp = [ aaii( 2 ); -aaii( 1 ) ];
	endpoints = [ center + 10 * aaii_perp, center - 10 * aaii_perp ];
	line( endpoints( 1, : ), endpoints( 2, : ), 'Color', 'blue' );
	endpoints = endpoints + [ aaii, aaii ] * 0.1;
	line( endpoints( 1, : ), endpoints( 2, : ), 'Color', 'blue', 'LineStyle', ':' );
end
handle_gd = line( gd_xxs( 1, 1:( gd_iterations + 1 ) ), gd_xxs( 2, 1:( gd_iterations + 1 ) ), 'LineWidth', 2, 'Color', 'red', 'Marker', 'o' );
legend( handle_gd, sprintf( 'GD, %d iterations', gd_iterations ) );
hold off;
disp( 'Press any key to continue' );
pause;

contour( XX, YY, ZZ, ( ( 0.05:0.1:0.95 ) * ( upper - lower ) + lower ) .^ 2 );
colormap( gray );
hold on;
for ii = 1:length( bb )
	aaii = AA( ii, : )' / norm( AA( ii, : ) );
	bbii = bb( ii ) / norm( AA( ii, : ) );
	center = -aaii * bbii;
	aaii_perp = [ aaii( 2 ); -aaii( 1 ) ];
	endpoints = [ center + 10 * aaii_perp, center - 10 * aaii_perp ];
	line( endpoints( 1, : ), endpoints( 2, : ), 'Color', 'blue' );
	endpoints = endpoints + [ aaii, aaii ] * 0.1;
	line( endpoints( 1, : ), endpoints( 2, : ), 'Color', 'blue', 'LineStyle', ':' );
end
handle_newton = line( newton_xxs( 1, 1:( newton_iterations + 1 ) ), newton_xxs( 2, 1:( newton_iterations + 1 ) ), 'LineWidth', 2, 'Color', 'magenta', 'Marker', 'o' );
legend( handle_newton, sprintf( 'Newton, %d iterations', newton_iterations ) );
hold off;
disp( 'Press any key to continue' );
pause;

contour( XX, YY, ZZ, ( ( 0.05:0.1:0.95 ) * ( upper - lower ) + lower ) .^ 2 );
colormap( gray );
hold on;
for ii = 1:length( bb )
	aaii = AA( ii, : )' / norm( AA( ii, : ) );
	bbii = bb( ii ) / norm( AA( ii, : ) );
	center = -aaii * bbii;
	aaii_perp = [ aaii( 2 ); -aaii( 1 ) ];
	endpoints = [ center + 10 * aaii_perp, center - 10 * aaii_perp ];
	line( endpoints( 1, : ), endpoints( 2, : ), 'Color', 'blue' );
	endpoints = endpoints + [ aaii, aaii ] * 0.1;
	line( endpoints( 1, : ), endpoints( 2, : ), 'Color', 'blue', 'LineStyle', ':' );
end
handle_gd = line( gd_xxs( 1, : ), gd_xxs( 2, : ), 'LineWidth', 2, 'Color', 'red', 'Marker', 'o' );
handle_newton = line( newton_xxs( 1, : ), newton_xxs( 2, : ), 'LineWidth', 2, 'Color', 'magenta', 'Marker', 'o' );
legend( [ handle_gd, handle_newton ], sprintf( 'GD, %d iterations', gd_iterations ), sprintf( 'Newton, %d iterations', newton_iterations ) );
hold off;
